<template>
  <div>
    <!-- As a link -->
    <b-navbar type="dark" variant="dark">
      <b-container>
        <b-navbar-brand href="#">SGJ Delivery</b-navbar-brand>
      </b-container>
    </b-navbar>
    <b-container>
      <br />
      <b-form @submit="onSubmit" @reset="onReset" v-if="show">
        <b-form-group id="customer" label="Customer:" label-for="customer">
          <b-form-select
            id="customer"
            class="form-control"
            v-model="form.customer"
            :options="customers"
            required
          ></b-form-select>
        </b-form-group>
        <br />
        <b-form-group
          id="product_weight"
          label="ProductWeight:"
          label-for="product_weight"
        >
          <b-form-input
            id="product_weight"
            v-model="form.product"
            type="number"
            step="0.01"
            value="0.00"
            placeholder="ProductWeight"
            required
          ></b-form-input>
        </b-form-group>
        <br />

        <b-form-group id="box_weight" label="Box Weight:" label-for="box_weight">
          <b-form-input
            id="box_weight"
            v-model="form.box"
            type="number"
            step="0.01"
            value="0.00"
            placeholder="BoxWeight"
            required
          ></b-form-input>
        </b-form-group>
        <br/>
        <b-button type="reset" variant="danger">Reset</b-button>
        <b-button variant="success" @click="generateReport" ali>Print</b-button>
        <br/>
        <br />
        <b-form-group
          id="total_weight"
          label="Total Weight:"
          label-for="total_weight"
        >
          <b-form-input
            id="total_weight"
            v-model="form.total"
            type="text"
            placeholder="Total Weight"
            disabled
          ></b-form-input>
        </b-form-group>

      </b-form>
    </b-container>
    <vue-html2pdf
        :show-layout="false"
        :float-layout="true"
        :enable-download="true"
        :paginate-elements-by-height="1100"
        :pdf-quality="2"
        :manual-pagination="false"
        pdf-format="a6"
        pdf-orientation="portrait"
        pdf-content-width="500px"
        pdf-content-height="100px"
        ref="html2Pdf"
    >
        <section slot="pdf-content">
        <div>
        <b-container>
          <b-card-group deck>
            <br/>
          <b-card style="max-width: 20rem;">
            
          <canvas id="qrcodeE" class="center"></canvas>
       
        <br/>
    
        <h5>ชื่อลูกค้า : {{ form.customer }}</h5>
        <h5>น้ำหนักทอง :{{ form.product }} กรัม</h5>
        <h5>น้ำหนักกล่อง : {{ form.box }} กรัม</h5>
        <h5>น้ำหนักรวม : {{ form.total }} กรัม</h5>
  
        </b-card>  
        </b-card-group>     
        </b-container>
        </div>
        </section>
    </vue-html2pdf>
  </div>
</template>

<script>
import VueHtml2pdf from "vue-html2pdf";
import QRCode from 'qrcode';
export default {
  components: {
    VueHtml2pdf,
  },
  data() {
    return {
      form: {
        product: "",
        box: "",
        total: "",
        customers: null
      },
      customers: [
        
        { text: "กรุณาเลือก", value: null },
        { text: "ห้างทองเอกเซ่งเฮง", value: "ห้างทองเอกเซ่งเฮง" },
        { text: "ห้างทองทองดี", value: "ห้างทองทองดี" },
        { text: "ห้างทองจันทร์สม", value: "ห้างทองจันทร์สม" },
        { text: "ห้างทองโต๊ะกัง", value: "ห้างทองโต๊ะกัง" }
      ],
      show: true,
    };
  },
  methods: {
    onSubmit(event) {
      event.preventDefault();
      alert(JSON.stringify(this.form));
    },
    onReset(event) {
      event.preventDefault();
      // Reset our form values
      this.form.customer = [];
      this.form.product = "";
      this.form.box = "";
      this.form.total = "";
      // Trick to reset/clear native browser form validation state
      this.show = false;
      this.$nextTick(() => {
        this.show = true;
      });
    },
    generateReport() {
      var canvas = document.getElementById('qrcodeE');
      if(canvas){
        QRCode.toCanvas(canvas, this.form.customer, function (error) {
          if (error) console.error(error)

        })
        this.$refs.html2Pdf.generatePdf();
      }

    }
  }
};
</script>
